_num_params WORD 0
_param	WORD 0,0,0,0
_opcode WORD 0
paramptr BYTE 0
modes	BYTE 0

_interp
	lda _gflags
	cmp #5
	beq interpEnd
interpLoop
	ldy _pc_offset
	lda (_pc_ptr),y
	inc _pc_offset
	bne *+5
	jsr _fix_pc1
	sta _opcode

; jsr trace_pc
; jsr trace_opcode
	bit _opcode
	bpl oper2
	bvs oper3
	jmp oper1
interpEnd
	rts

oper2
	ldx #2
	stx _num_params
	bit _opcode
	bvs loadparam1
	ldx #1
loadparam1
	jsr load
	stx _param+0
	sta _param+1

	ldx #2
	lda #$20
	bit _opcode
	bne loadparam2
	ldx #1
loadparam2
	jsr load
	stx _param+2
	sta _param+3

	lda _opcode
	and #$1F
	jmp execute

oper3
;	lda #0
;	sta _param+0
;	sta _param+1
;	sta _param+2
;	sta _param+3
;	sta _param+4
;	sta _param+5
;	sta _param+6
;	sta _param+7
	ldy _pc_offset
	lda (_pc_ptr),y
	inc _pc_offset
	bne *+5
	jsr _fix_pc1
	sta modes

	ldx #0
	and #$C0
	cmp #$C0
	beq endparam
	asl a
	rol a
	rol a
	tax
	jsr load
	stx _param
	sta _param+1

	ldx #1
	lda modes
	and #$30
	cmp #$30
	beq endparam
	lsr a
	lsr a
	lsr a
	lsr a
	tax
	jsr load
	stx _param+2
	sta _param+3

	ldx #2
	lda modes
	and #$0C
	cmp #$0C
	beq endparam
	lsr a
	lsr a
	tax
	jsr load
	stx _param+4
	sta _param+5

	ldx #3
	lda modes
	and #3
	cmp #3
	beq endparam
	tax
	jsr load
	stx _param+6
	sta _param+7
	ldx #4
endparam
	stx _num_params
	lda _opcode
	and #$3F

execute
	asl a
	tax
	lda op2tab,x
	sta switch2+1
	lda op2tab+1,x
	sta switch2+2
	ldy #0
switch2
	jsr $0000
	jmp _interp


oper1
	lda _opcode
	cmp #$B0
	bcs misc
	lsr a
	lsr a
	lsr a
	lsr a
	and #3
	tax
	jsr load
	stx _param+0
	sta _param+1
	lda _opcode
	and #$0F
	asl a
	tax
	lda op1tab,x
	sta switch1+1
	lda op1tab+1,x
	sta switch1+2
	ldy #0
switch1
	jsr $0000
	jmp _interp

misc
	and #$0F
	asl a
	tax
	lda misctab,x
	sta switch+1
	lda misctab+1,x
	sta switch+2
	ldy #0
switch
	jsr $0000
	jmp _interp

invalid
	ldy #0
	lda #LOW(inv_opcode_msg)
	sta (sp),y
	iny
	lda #HIGH(inv_opcode_msg)
	sta (sp),y
	iny
	jsr _printf
	jmp _exit

inv_opcode_msg 
	STRING "Invalid opcode !"
	BYTE $0a,$00

unimplemented
	rts

op1tab
	WORD _cp_zero
	WORD _get_link
	WORD _get_holds
	WORD _get_loc
	WORD _get_prop_len
	WORD _inc_var
	WORD _dec_var
	WORD _print1

	WORD invalid
	WORD _remove_obj
	WORD _p_obj
	WORD _rtn
	WORD _jump
	WORD _print2
	WORD _get_var
	WORD _not

op2tab
	WORD invalid
	WORD _compare
	WORD _LTE
	WORD _GTE
	WORD _dec_chk
	WORD _inc_chk
	WORD _check_loc
	WORD _bit

	WORD _or
	WORD _and
	WORD _test_attr
	WORD _set_attr
	WORD _clr_attr
	WORD _put_var
	WORD _transfer
	WORD _load_word_array

	WORD _load_byte_array
	WORD _get_prop
	WORD _get_prop_addr
	WORD _next_prop
	WORD _plus
	WORD _minus
	WORD _multiply
	WORD _divide

	WORD _mod
	WORD invalid
	WORD invalid
	WORD invalid
	WORD invalid
	WORD invalid
	WORD invalid
	WORD invalid

	WORD _gosub
	WORD _save_word_array
	WORD _save_byte_array
	WORD _put_prop
	WORD _input
	WORD _print_char
	WORD _print_num
	WORD _pi_random

	WORD _push
	WORD _pop
	WORD invalid
	WORD invalid
	WORD invalid
	WORD invalid
	WORD invalid
	WORD invalid

	WORD invalid
	WORD invalid
	WORD invalid
	WORD unimplemented
	WORD unimplemented
	WORD _bell
	WORD invalid
	WORD invalid

	WORD invalid
	WORD invalid
	WORD invalid
	WORD invalid
	WORD invalid
	WORD invalid
	WORD invalid
	WORD invalid

misctab
	WORD _rtn1
	WORD _rtn0
	WORD _wrt
	WORD _writeln
	WORD invalid
	WORD _save
	WORD _restore
	WORD _restart

	WORD _rts
	WORD _pop_stack
	WORD _quit
	WORD _new_line
	WORD _set_score
	WORD invalid
	WORD invalid
	WORD invalid
