stack_start equ $b800

_stack	equ $4a
_stack_var_ptr equ $4c
_pc_ptr equ $4e

ap	equ $50
fp	equ ap+2
sp	equ fp+2
tmp0	equ sp+2
tmp1	equ tmp0+2
tmp2	equ tmp1+2
tmp3	equ tmp2+2
tmp4	equ tmp3+2
tmp5	equ tmp4+2
tmp6	equ tmp5+2
tmp7	equ tmp6+2
op1	equ tmp7+2
op2	equ op1+2
tmp	equ op2+2
reg0	equ tmp+2
reg1	equ reg0+2
reg2	equ reg1+2
reg3	equ reg2+2
reg4	equ reg3+2
reg5	equ reg4+2
reg6	equ reg5+2
reg7	equ reg6+2

switch_ovl equ $04f2

	org $500

	tsx
	stx retstack

	lda $0239
	sta old_vdu+1
	lda $023a
	sta old_vdu+2
	lda #LOW new_vdu
	sta $0239
	lda #HIGH new_vdu
	sta $023a

	lda $023c
	sta old_kbd+1
	lda $023d
	sta old_kbd+2
	lda #LOW new_kbd
	sta $023c
	lda #HIGH new_kbd
	sta $023d

	jsr switch_ovl

	lda #LOW stack_start
	sta sp
	lda #HIGH stack_start
	sta sp+1
	ldy #0
	jsr _main

	jmp switch_ovl

retstack	byte 0

new_vdu jsr switch_ovl
old_vdu	jsr $0238
	jmp switch_ovl

new_kbd jsr switch_ovl
old_kbd	jsr $023b
	jmp switch_ovl

enter
	sty tmp
	stx tmp+1
	asl a
	sta op2
	tax
	beq noregstosave
savereg	lda reg0-1,x
	sta (sp),y
	iny
	dex
	bne savereg
noregstosave
	sty op2+1
	lda ap
	sta (sp),y
	iny
	lda ap+1
	sta (sp),y
	iny
	lda fp
	sta (sp),y
	iny
	lda fp+1
	sta (sp),y
	iny
	lda op2
	sta (sp),y
	iny
	lda tmp
	sta (sp),y
	clc
	lda sp
	sta ap
	adc op2+1
	sta fp
	lda sp+1
	sta ap+1
	adc #0
	sta fp+1
	lda tmp+1
	adc fp
	sta sp
	lda fp+1
	adc #0
	sta sp+1
	rts

leave
	stx op2
	sta op2+1
	lda ap
	sta sp
	lda ap+1
	sta sp+1
	ldy #4
	lda (fp),y
	tax
	iny
	lda (fp),y
	tay
	txa
	beq noregstorestore
restorereg
	lda (sp),y
	sta reg0-1,x
	iny
	dex
	bne restorereg
noregstorestore
	ldy #0
	lda (fp),y
	sta ap
	iny
	lda (fp),y
	sta ap+1
	iny
	lda (fp),y
	tax
	iny
	lda (fp),y
	stx fp
	sta fp+1
	ldx op2
	lda op2+1
	rts

jsrvect jmp (0000)
