;
; printf(str,...)
;
_printf
	ldy #0
	lda (sp),y
	sta tmp
	iny
	lda (sp),y
	sta tmp+1
	iny
	sty saveptrarg

	ldy #0
formloop
	lda (tmp),y
	tax
	beq endform
	cmp #$0A
	beq linefeed
	cmp #$25	; if '%'
	beq formfield
charput
	jsr $0238
	iny
	bne formloop	; size format string < 256
endform
	rts
linefeed
	jsr $0238
	ldx #$0D
	jmp charput
formfield
	iny
	lda (tmp),y
	cmp #$64
	beq printint
	cmp #$73
	beq printstr
	cmp #$63
	beq printchar
	cmp #$78
	beq printhex
	jmp charput
printchar
	sty saveptrform
	ldy saveptrarg
	lda (sp),y
	tax
	iny
	iny
	sty saveptrarg
	ldy saveptrform
	jmp charput
printstr
	iny
	sty saveptrform
	ldy saveptrarg
	lda (sp),y
	sta op2
	iny
	lda (sp),y
	sta op2+1
	iny
	sty saveptrarg
	ldy #0
prtsloop
	lda (op2),y
	tax
	beq endprts
	jsr $0238
	iny
	bne prtsloop
	inc op2+1
	jmp prtsloop
endprts
	ldy saveptrform
	jmp formloop
printint
	iny
	sty saveptrform
	jsr nextarg
	jsr itoa
	stx op2
	sta op2+1
	ldy #0
	jmp prtsloop

printhex
	iny
	sty saveptrform
	jsr nextarg
	lda op2+1
	beq *+5
	jsr hexbyte
	lda op2
	jsr hexbyte
	ldy saveptrform
	jmp formloop

saveptrform
	byte 0
saveform
	byte 0,0
saveptrarg
	byte 0

hexbyte
	tay 
	lsr a
	lsr a
	lsr a
	lsr a
	jsr nibble
	tya
	and #$0F
nibble
	cmp #10
	bcc chiffre
	adc #6
chiffre
	adc #$30
	tax
	jmp $0238

nextarg
	ldy saveptrarg
	lda (sp),y
	sta op2
	iny
	lda (sp),y
	sta op2+1
	iny
	sty saveptrarg
	rts
