;
; stprintf(str,...)
;
; Warning, This is a kludge to use printf to
; format-print in the status line
; It changes XVDU to point to an special routine
; instead of to VDU, and then calls _printf
ST_LINE EQU 48000
_stprintf

	; Initialize a counter
	lda #0
	sta tx_count2
				
    ; Save old value of XVDU
	lda $239
	sta tx_addr2
	lda $23A
	sta tx_addr2+1
	
	; Make XVDU point to new routine
    lda #LOW tx_stbuff
	sta $239
	lda #HIGH tx_stbuff
	sta $23A
    
	; Call to _printf
    jsr _printf
	
	; Restore XVDU pointer
	lda tx_addr2
	sta $239
	lda tx_addr2+1
	sta $23A
	
	; We're done!
	rts

tx_stbuff	
	; Get character to print &
	; store it in status line+counter
	pha
	tya
	pha
	lda #LOW ST_LINE
	sta tmp1
	lda #HIGH ST_LINE
	sta tmp1+1
	ldy tx_count2
	txa
	sta (tmp1),y
    inc tx_count2
	pla
	tay
	pla
  	rts

; Buffers
tx_addr2
    byte 0,0
tx_count2
    byte 0

